Unit IAC1R1_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc;

function IAC1R1(var TX :Array of Real; var CX :Array of Real;
                LX :Integer; JX :Integer): Real;

implementation

function IAC1R1(var TX :Array of Real; var CX :Array of Real;
                LX :Integer; JX :Integer): Real;
var
I,J :Integer;
A,B,C,D :Real;
const
C1 :Real = 1.0;
C112 :Real = 112.0;
C13 :Real = 13.0;
C240 :Real = 240.0;
C3 :Real = 3.0;
C438 :Real = 438.0;
K1 :Integer = 1;
label
_10,_20;
begin
{ Result -    IAC1R1  FORTRANe }
A  := CX[JX-1];
if ( LX  <  K1 ) 
 then goto _20;
I  := JX + K1;
J  := JX - K1;
if ( LX  >  K1 ) 
 then goto _10;
B  := TX[I-1] - TX[JX-1];
C  := TX[JX-1] - TX[J-1];
D  := C*C/B/(B + C);
C  := B*B/C/(B + C);
B  := C1/C/D;
A  := (B*A - C*CX[J-1] - D*CX[I-1])/C3;
goto _20;
_10:
B  := CX[J-1] + CX[I-1];
I  := I + K1;
J  := J - K1;
C  := CX[J-1] + CX[I-1];
A  := (C438*A - C112*B + C13*C)/C240;
_20:
Result := A;
exit;
end;

end.
