Unit IAS1R2_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc;

function IAS1R2(var TX :Array of Real; var CX :Array of Real;
                KX :Integer; IDX :Integer; XX :Real; IX :Integer;
                JX :Integer): Real;

implementation

function IAS1R2(var TX :Array of Real; var CX :Array of Real;
                KX :Integer; IDX :Integer; XX :Real; IX :Integer;
                JX :Integer): Real;
var
I,J,K,L,M,N,N1 :Integer;
A :Array [0..7] of Real;
B :Array [0..6] of Real;
C :Array [0..6] of Real;
const
K1 :Integer = 1;
label
_10,_20,_30,_40,_50,_60,_70,_80;
begin
{ Result -    IAS1R2  FORTRANe }
I  := JX*(IX - KX + K1);
for J:=K1 to KX do
 begin
  K  := I + J;
  A[J-1] := CX[K-1];
_10:
 end;
if ( IDX  <  K1 ) 
 then goto _40;
for I:=K1 to IDX do
 begin
  J  := KX - I;
  for K:=K1 to J do
   begin
    L  := IX + K;
    M  := L - J;
    N  := K + K1;
    A[K-1] := (A[N-1] - A[K-1])/(TX[L-1] - TX[M-1])*J;
_20:
   end;
_30:
 end;
_40:
I  := KX - IDX - K1;
if ( I  <  K1 ) 
 then goto _80;
for J:=K1 to I do
 begin
  K  := IX + J;
  B[J-1] := TX[K-1] - XX;
  K  := IX + K1 - J;
  C[J-1] := XX - TX[K-1];
_50:
 end;
N1  := KX - K1;
I  := IDX + K1;
for J:=I to N1 do
 begin
  K  := KX - J;
  for L:=K1 to K do
   begin
    M  := K + K1 - L;
    N  := L + K1;
    A[L-1] := (A[N-1]*C[M-1] + A[L-1]*B[L-1])/(C[M-1] + B[L-1]);
_60:
   end;
_70:
 end;
_80:
Result := A[K1-1];
exit;
end;

end.
